Cylindref(L):={
local O,OO,M,MM,,couche,typdes;

O:=L[0];
M:=L[1];
OO:=L[2];
MM:=L[3];
couche:=L[4];
typdes:=L[5];
                        //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                        //       % Creation du fichier metapost

if(couche=="couche") then
{
   Dessin:="
input dlf\_tex.mp;
input geometriesyr16.mp;

u:=1cm;
typetrace:=\""+typdes+"\";
_tfig:=12cm;
beginfig(0);
pair A,B,O,AA,BB,OO,M,MM,I;

numeric rb;
rb:=1.5;     % rayon de base
pair V;
V:=(3u,1u);      % vecteur

O=(0,0);
OO:= O shifted V;

path cc;
cc= fullcircle scaled (2*rb*u);


path d;
d:=O--OO;
I := d intersectionpoint cc;
A:= I rotatedaround(O,270);
AA:= A shifted V;

B= -A;
BB:= B shifted V;

numeric ang;

ang:=340;  % angle servant a placer M

M:=point (length cc *ang/360) of cc;
MM:= M shifted V;


trace arccercle(B,A,O);
trace arccercle(A,M,O);
trace arccercle(M,B,O);


trace arccercle(BB,AA,OO) dashed evenly;
trace arccercle(AA,MM,OO);
trace arccercle(MM,BB,OO);

trace chemin(A,AA);
trace chemin(B,BB);
trace chemin(O,OO) dashed evenly;


trace chemin(O,M);
trace codeperp(M,O,OO,5);


trace chemin(OO,MM);
trace chemin(M,MM);
trace codeperp(O,OO,MM,5);

label.lft(TEX(\" $"+O+"$ \"),O);
label.top(TEX(\" $"+OO+"$ \"),OO);
label.lrt(TEX(\" $"+M+"$ \"),M);
label.lrt(TEX(\" $"+MM+"$ \"),MM);


endfig;
typetrace:=\"normal\";

end
";
}
else
{
   Dessin:="
input dlf\_tex.mp;
input geometriesyr16.mp;

u:=1cm;
typetrace:=\""+typdes+"\";
_tfig:=12cm;
beginfig(0);
pair A,B,O,AA,BB,OO,M,MM;

numeric rb,h;
rb:=1.5;     % rayon de base
h:=3;      % hauteur

O=(0,0);
OO:= O shifted (0,h*u);
A=(-rb*u,0);
AA:= A shifted (0,h*u);
B=(rb*u,0);
BB:= B shifted (0,h*u);


numeric ang;

ang:=300;  % angle servant a placer M

M:=B rotatedaround(O,ang);


trace arccercle(B,A,O) yscaled 0.2 dashed evenly;
trace arccercle(A,M,O) yscaled 0.2;
trace arccercle(M,B,O) yscaled 0.2;

trace arccercle(B,A,O) yscaled 0.2 shifted (0,h*u);
trace arccercle(A,M,O) yscaled 0.2 shifted (0,h*u);
trace arccercle(M,B,O) yscaled 0.2 shifted (0,h*u);



trace chemin(A,AA);
trace chemin(B,BB);
trace chemin(O,OO) dashed evenly;

M:=M yscaled 0.2;

trace chemin(O,M) dashed evenly;
trace codeperp(M,O,OO,5);

MM:= M shifted(0,h*u);
trace chemin(OO,MM);
trace chemin(M,MM);
trace codeperp(O,OO,MM,5);

label.lft(TEX(\" $"+O+"$ \"),O);
label.lft(TEX(\" $"+OO+"$ \"),OO);
label.lrt(TEX(\" $"+M+"$ \"),M);
label.top(TEX(\" $"+MM+"$ \"),MM);


endfig;
typetrace:=\"normal\";

end
";
}




}:;

